import codecs
import string
import socket
import asyncore
import asynchat
import sys
import time
import thread
import threading
import urllib
from exceptions import Exception
from asynchat import fifo

DEFAULT_HOST = "messenger.hotmail.com"
DEFAULT_PORT = 1863
DEFAULT_PROTOCOL = "MSNP2"

MIME_HEADER = "MIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\nX-MMS-IM-Format: FN=MS%20Sans%20Serif; EF=; CO=0; CS=0; PF=0\r\n\r\n"
ExitNow = 'Time Out'

class msn_chat(asynchat.async_chat):
    def __init__(self, console, main_chat, addr, debug=0):
        asynchat.async_chat.__init__(self)
        
        self.create_socket(socket.AF_INET, socket.SOCK_STREAM)
        if debug:
            print("connecting to addr : ", addr)
        self.connect(addr)
        self.set_terminator('\r\n')
        self.trid = 20
        self.id = ''
        self.passwd = ''
        self.sp = ''
        self.data = ''
        self.msn_connected = 0
        self.authChanllengeInfo = ''
        self.QueueCommand = {}
        self.msg_collecting = 0
        self.msg_fifo = fifo()
        self.state = ''
        self.channels = []
        if main_chat == None:
            self.main_chat = self
        else:
            self.main_chat = main_chat
        self.main_chat.channels.append(self)
        self.console = console
        
    def set_console(self, console):
        self.console = console
    def collect_incoming_data(self, data):
        self.data = self.data + data
    def found_terminator(self):
        # parsing data from server
        #  and call appopriate function
        self.set_terminator("\r\n")

        line = self.data
        self.data = ''
        print("<<<", line)
        sys.stdout.flush()

        try:
            recv_line = string.split(line, ' ')
            cmd_name = recv_line[0]
            trid = recv_line[1]
        except IndexError:
            trid = 0
            pass

        name = "handle%s" % cmd_name

        # Defferent Handling for Client Initialized Action
        #                and for Server Initialized Action
        if (self.QueueCommand.has_key(trid)):
            # for Client Triggered Action
            #  when trigger, register trid and callbackfunc
            reg_cmd_name = self.QueueCommand[trid][0]
            callbackfunc = self.QueueCommand[trid][1]

            if type(callbackfunc) == type(self.found_terminator):
                callbackfunc(recv_line)
            else:
                raise Exception("registered callbackfunc is invalid")
        else:
            # for Server Triggered Action
            #   We Don't Have trid, should response!
            if hasattr(self, name):
                #make sure it's a method
                method = getattr(self, name)
                if type(method) == type(self.found_terminator):
                    print("calling %s(%s)" % (method, recv_line))
                    method(recv_line)
            else:
                #print('unknown command : %s' % recv_line[0])
                pass

    def handle_close(self):
        self.close()

    def close(self):
        asynchat.async_chat.close(self)

    # -----------------------------------
    # MSN_CHAT Specific Functions
    # -----------------------------------
    def push_line(self, command, callbackfunc):
        tmp = string.split(command)
        trid = tmp[1]
        cmd = tmp[0]
        self.QueueCommand[trid] = (cmd, callbackfunc)
        #print("=== before push : ", asyncore.socket_map)
        print(">>>" + command )
        self.push(command + "\r\n")
        #print("=== after push : ", asyncore.socket_map)
    
    def newTrID(self):
        self.trid = self.trid + 1
        return self.trid
    
    def handleMSG(self, arglist):
        print("set_terminator : ", int(arglist[3]))
        self.set_terminator(int(arglist[3]))
        pass

    def handleXFR(self, arglist):
        #global mmc
        
        # def handleXFR(self, serverType, serverHostPort):
        #  serverHostPort : xxx.xxx.xxx.xxx:xx
        trID = arglist[1]
        referralType = arglist[2]
        serverHostPort = arglist[3]
        ip = string.split(serverHostPort, ":")[0]
        port = int(string.split(serverHostPort, ":")[1])

        if referralType == "NS":
            tmp = msn_chat(sys.stdout, self, (ip, port))
            tmp.authenticate_user_md5(self.id, self.passwd)
            print "=== differ"
            print "=== after XFR tmp: ", tmp
            
            self.main_chat = tmp            
            self = self.main_chat
            print "=== after XFR self: ", self
        elif referralType == "SB":
            sp = arglist[4]
            authChallenge = arglist[5]
            tmp = msn_chat(sys.stdout, self, (ip, port))
            tmp._authenticate_sb_session(self.id, authChallenge)
            self.sb = tmp

    def handleVER(self, arglist):
        trID = arglist[1]
        dialectName = arglist[2]
        pass

    def handleINF(self, arglist):
        trID = arglist[1]
        self.sp = arglist[2]

    def handleUSR(self, arglist):
        trID = arglist[1]
        sp = arglist[2]
        if arglist[3] == "S":
            import md5
            # response for first auth req.
            self.authChallengeInfo = arglist[4]
            self.authstate = 2
            m = md5.new()
            m.update(self.authChallengeInfo)
            m.update(self.passwd)
            self.push_line("%s %lu %s S %s" %
                           ("USR", self.newTrID(), "MD5", m.hexdigest()) )
        if arglist[2] == "OK":
            self.main_chat.msn_connected = 1
            userHandle = arglist[3]
            friendlyName = arglist[4]
            print("Login OK : %s %s" % (userHandle, friendlyName))
            
    def handle_connect(self):
        pass
        
        
    def do_nothing(self, arglist):
        # do_nothing for cmd like VER, INF
        pass
    
    def _debug_print_queue_command():
        print("---------------------------------------------------")
        print("TRID\t\tCMD\t\t")
        for elm in self.QueueCommand.keys():
            print(elm, "\t\t", self.QueueCommand[elm])
        print("")
        print("")
        
    def set_protocol(self, protocol):
        self.push_line("%s %lu %s" % ("VER", self.newTrID(), protocol), self.do_nothing)
        
    def get_server_policy_info(self):
        self.push_line("%s %lu" % ("INF", self.newTrID()), self.do_nothing)
        
    def _handleAuthRes1(self, arglist):
        if (arglist[0] == "XFR"):
            self.handleXFR(arglist)
            return
        
        import md5
        # response for first auth req.
        self.authChallengeInfo = arglist[4]
        self.authstate = 2
        m = md5.new()
        m.update(self.authChallengeInfo)
        m.update(self.passwd)
        self.push_line("%s %lu %s S %s" %
                       ("USR", self.newTrID(), "MD5", m.hexdigest()), self._handleAuthRes2 )
        
    def _handleAuthRes2(self, arglist):
        # FULL AUTH PINGPONG LIST
        #
        # C: USR TrID SP I{ AuthInitiateInfo}
        # S: USR TrID SP S{ AuthChallengeInfo}
        # C: USR TrID SP S{ AuthResponseInfo }
        # S: USR TrID OK UserHandle FriendlyName
        try:
            if (arglist[2] == "OK"):
                self.main_chat.msn_connected = 1
                userHandle = arglist[3]
                friendlyName = arglist[4]
                print("Login OK : %s %s" % (userHandle, friendlyName))
            else:
                # Never Happen?
                print("Login Failed : Please Check ID/PASS")
        except IndexError:
            raise Exception("Auth Failed")
            
    def syncronize(self):
        self.push_line("%s %lu 4" % ("SYN", self.newTrID()), self.do_nothing)
        
    def change_state(self, state):
        commandLine = "%s %lu %s" % ("CHG", self.newTrID(), state)
        self.push_line(commandLine, self.do_nothing)
        
    def handleCHG(self,arglist):
        self.state=arglist[2]

    def _authenticate_sb_session(self, userHandle, authChallengeInfo):
        self.push_line("%s %lu %s %s" %
                       ("USR", self.newTrID(), userHandle, authChallengeInfo),
                       self._handleSbAuthRes)

    def _handleSbAuthRes(self, arglist):
        # SwitchBoard Session Auth
        #
        # C: USR TrID UserHandle AuthResponseInfo
        # S: USR TrID OK UserHandle FriendlyName
        if (arglist[2] == "OK"):
            print("Login OK : %s, %s" % (arglist[3], arglist[4]))
            self.main_chat.sb_session_complete = 1
        else:
            print("Login Failed")

    def make_sb_session(self):
        self.sb_session_complete = 0
        commandLine = "%s %lu SB" % ("XFR", self.newTrID())
        self.push_line(commandLine, self.handleXFR)
        start = time.time()
        while not (self.sb_session_complete):
            time.sleep(0.000001)
            if (time.time() - start > 20):
                raise ExitNow
        return self.sb
       
    def invite(self, userHandle):
        #assert self.connect_type == "SB", "can be called only in SB"
        commandLine = "%s %lu %s" % ("CAL", self.newTrID(), userHandle)
        self.push_line(commandLine, self.do_nothing)
        
    def send_msg(self, msg):
        #assert self.connect_type == "SB", "can be called only in SB"
        (UTF8_encode, UTF8_decode,
         UTF8_streamreader, UTF8_streamwriter) = codecs.lookup('UTF-8')
        (umsg, ulen) = UTF8_encode(unicode(msg))

        commandLine = "%s %lu A %d\r\n%s%s" % \
                    ("MSG", self.newTrID(), len(MIME_HEADER)+len(umsg),
                    MIME_HEADER, umsg)
        time.sleep(3)
        print(">>>", commandLine)
        self.push(commandLine)
    
    def authenticate_user_md5(self, id, passwd):
        self.id = id
        self.passwd = passwd
        commandLine = "%s %lu %s I %s" % \
                      ("USR", self.newTrID(), "MD5", id)
        self.push_line(commandLine, self._handleAuthRes1)
    
def test():
    global mmc
    
    time.sleep(0.1)
    id, passwd = "xxxxx@hotmail.com", "xxxxx"
    
    mmc.set_protocol(DEFAULT_PROTOCOL)
    mmc.get_server_policy_info()
    mmc.authenticate_user_md5(id, passwd)

    print("authenticate_user_md5 called")
    start = time.time()
    while not (mmc.msn_connected):
        time.sleep(0.000001)
        if (time.time() - start > 20):
            print("time out!!!")
            sys.exit()


    print("after connection in thread")
    print "=== after XFR mmc: ", mmc

    mmc = mmc.main_chat    
    mmc.syncronize()
    mmc.change_state("NLN")

    sb = mmc.make_sb_session()
    sb.invite("yyyyy@hotmail.com")
    sb.send_msg("hi")
    
if __name__ == "__main__":
    global mmc
    mmc = msn_chat(sys.stdout, None, (DEFAULT_HOST, DEFAULT_PORT))
    print "=== main loop's : ", mmc
    thread.start_new(test, ())
    asyncore.loop()
